package org.seasar.jsf.webapp;

import java.io.IOException;
import java.io.InputStream;

import junit.framework.TestCase;

import org.seasar.framework.util.ResourceUtil;

/**
 * @author manhole
 */
public class WebappConfigBuilderTest extends TestCase {

    public void testContextParam() throws Exception {
        // ## Act ##
        WebappConfig webappConfig = buildWebappConfig();

        // ## Assert ##
        assertNotNull("webappConfig邱", webappConfig);
        ContextParam contextParam = webappConfig
            .getContextParam("javax.faces.CONFIG_FILES");
        assertNotNull("contextParam[javax.faces.CONFIG_FILES]擾ł邱",
            contextParam);

        assertEquals("context-param/param-value擾ł邱",
            "/WEB-INF/faces-config.xml", contextParam.getParamValue());
        assertEquals("context-param/param-name擾ł邱",
            "javax.faces.CONFIG_FILES", contextParam.getParamName());

        assertEquals(
            "javax.faces.DEFAULT_SUFFIXcontext-param/param-value擾ł邱",
            ".html", webappConfig.getContextParam("javax.faces.DEFAULT_SUFFIX")
                .getParamValue());
    }

    public void testServlet() throws Exception {
        // ## Act ##
        WebappConfig webappConfig = buildWebappConfig();

        // ## Assert ##
        {
            Servlet servlet = webappConfig.getServlet("Faces Servlet");
            assertEquals("servlet/servlet-name擾ł邱", "Faces Servlet",
                servlet.getServletName());
            assertEquals("servlet/servlet-class擾ł邱",
                "javax.faces.webapp.FacesServlet", servlet.getServletClass());
            assertEquals("servlet/load-on-startup擾ł邱", "2", servlet
                .getLoadOnStartup());
        }
        {
            Servlet servlet = webappConfig.getServlet("s2servlet");
            InitParam initParam = servlet.getInitParam("debug");
            assertNotNull("servlet/init-param擾ł邱", initParam);
            assertEquals("servlet/init-param/param-name擾ł邱", "debug",
                initParam.getParamName());
            assertEquals("servlet/init-param/param-value擾ł邱", "true",
                initParam.getParamValue());
        }
    }

    private WebappConfig buildWebappConfig() throws IOException {
        // ## Arrange ##
        WebappConfigBuilder builder = new WebappConfigBuilder();
        InputStream is = ResourceUtil.getResourceAsStream(getClass()
            .getPackage().getName().replace('.', '/')
            + "/WebappConfigBuilderTest-web.xml");

        // ## Act ##
        WebappConfig webappConfig = builder.build(is);
        is.close();
        return webappConfig;
    }

}
